//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  DarkGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern string StPeriods       = "10;15;20;";
extern string StMultipliers   = "1.7;1.7;1.7;";
extern int    Price           = PRICE_CLOSE;

//
//
//
//
//

double Buffer0[];
double Buffer1[];
double Buffer2[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

int    size;
double periods[];
double multipliers[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Buffer0); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer2); SetIndexStyle(2,DRAW_HISTOGRAM);

      //
      //
      //
      //
      //
      
         if (StringSubstr(StPeriods,StringLen(StPeriods)-1,1) != ";")
                          StPeriods = StringConcatenate(StPeriods,";");
            int s = 0;
            int i = StringFind(StPeriods,";",s);
            double current;
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StPeriods,s,i-s));
                  if (current > 0) {
                        ArrayResize(periods,ArraySize(periods)+1);
                                    periods[ArraySize(periods)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StPeriods,";",s);
               }
               size = ArraySize(periods);

         //
         //
         //
         //
         //
      
         if (StringSubstr(StMultipliers,StringLen(StMultipliers)-1,1) != ";")
                          StMultipliers = StringConcatenate(StMultipliers,";");
            s = 0;
            i = StringFind(StMultipliers,";",s);
               while (i > 0)
               {
                  current = StrToDouble(StringSubstr(StMultipliers,s,i-s));
                  if (current > 0) {
                        ArrayResize(multipliers,ArraySize(multipliers)+1);
                                    multipliers[ArraySize(multipliers)-1] = current; }
                                    s = i + 1;
                                        i = StringFind(StMultipliers,";",s);
               }


      //
      //
      //
      //
      //

         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName(timeFrameToString(timeFrame)+" supertrend rayphua");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer0[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i >= 0; i--)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         int    sum   = 0;
         for (int k=0; k<size; k++)
         {
            double st = iCustom(NULL,0,"SuperTrendXAlertsMtf","","",periods[k],multipliers[k],0,i);
            if (price>st) sum++;
            if (price<st) sum--;
         }
         Buffer0[i] = EMPTY_VALUE;
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
            if (sum== size) { Buffer0[i] = 1; continue; }
            if (sum==-size) { Buffer1[i] = 1; continue; }
                              Buffer2[i] = 1; 
      }         
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);               
          Buffer0[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StPeriods,StMultipliers,Price,0,y);
          Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StPeriods,StMultipliers,Price,1,y);
          Buffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",StPeriods,StMultipliers,Price,2,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}